<?php
/**
 * Main functionality
 **/




/** Hook plugin's action and filters **/
function msp_helloworld_init(){
    
    add_action('init', 'msp_helloworld_taxonomies');
    add_filter('the_content', 'msp_helloworld_author_block_filter');
    add_filter('post_class', 'msp_helloworld_post_class');
    
}
add_action('plugins_loaded', 'msp_helloworld_init');

/** Register custom taxonomy **/
function msp_helloworld_taxonomies(){
    
    $args = array(
        'labels' => array(
            'name'          => 'Guest authors',
            'singular_name' => 'Guest author'
        ),        
        'show_in_nav_menus' => false        
    );
    
    register_taxonomy('gauthor', array('post'), $args);
    
}

/** Create author's box markup **/
function msp_helloworld_author_block(){
    global $post;
    
    $author_terms = wp_get_object_terms($post->ID, 'gauthor');
    if(empty($author_terms))
        return;
    
    $name = stripslashes($author_terms[0]->name);
    $url = esc_url(get_term_link($author_terms[0]));
    $desc = wp_filter_post_kses($author_terms[0]->description);
    
    $out = "<div class='gauthor-info'>";
    $out .= "<h5>This is a guest post by <a href='{$url}'>{$name}</a></h5>";
    $out .= "<div class='gauthor-desc'>{$desc}</div></div>";

    return $out;
}

/** Add author's box to the end of the post **/
function msp_helloworld_author_block_filter($content){
    
    if(is_single())
        $content .= msp_helloworld_author_block();
        
    return $content;
}

/** Add custom CSS class to the post's container **/
function msp_helloworld_post_class($post_class){
    global $post;
    
    $author_terms = wp_get_object_terms($post->ID, 'gauthor');
    if(!empty($author_terms)){
        $post_class[] = 'gauthor';
    }
    
    return $post_class;
}




?>